// RHtmlView.cpp : implementation file
//

#include "stdafx.h"
#include <..\src\occimpl.h>
#include "ROleControlSite.h"
#include "RHtmlView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// RHtmlView

IMPLEMENT_DYNCREATE(RHtmlView, CHtmlView)

RHtmlView::RHtmlView()
{
	//{{AFX_DATA_INIT(RHtmlView)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

RHtmlView::~RHtmlView()
{
}

void RHtmlView::DoDataExchange(CDataExchange* pDX)
{
	CHtmlView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(RHtmlView)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(RHtmlView, CHtmlView)
	//{{AFX_MSG_MAP(RHtmlView)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// RHtmlView diagnostics

#ifdef _DEBUG
void RHtmlView::AssertValid() const
{
	CHtmlView::AssertValid();
}

void RHtmlView::Dump(CDumpContext& dc) const
{
	CHtmlView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// RHtmlView message handlers

BOOL RHtmlView::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{
	///////////////////////////////////
	// The following does the same as MFC source, except that
	// AfxEnableControlContainer() is called with our handler.
	///////////////////////////////////

	CRect c_clientRect;
	GetClientRect(&c_clientRect);

	///////////////////////////////////
	// create the view window:

	m_pCreateContext = pContext;

	if (!CView::Create(lpszClassName, lpszWindowName, dwStyle, rect,
		pParentWnd,  nID, pContext))
	{
		return FALSE;
	}

	AfxEnableControlContainer(&m_pROccManager);

	///////////////////////////////////
	// create the control window:

	if (!m_wndBrowser.CreateControl(CLSID_WebBrowser, lpszWindowName,
				WS_VISIBLE | WS_CHILD, c_clientRect, this, AFX_IDW_PANE_FIRST))
	{
		DestroyWindow();
		return FALSE;
	}

	LPUNKNOWN lpUnk = m_wndBrowser.GetControlUnknown();
	HRESULT hr = lpUnk->QueryInterface(IID_IWebBrowser2, (void**) &m_pBrowserApp);
	if (!SUCCEEDED(hr))
	{
		m_pBrowserApp = NULL;
		m_wndBrowser.DestroyWindow();
		DestroyWindow();
		return FALSE;
	}

	///////////////////////////////////
	// Our initialisation:

	SetWindowText("RHtmlView");
	SetClassLong(this->m_hWnd, GCL_STYLE, CS_DBLCLKS);

	///////////////////////////////////

	return TRUE;	
}

/////////////////////////////////////////////////////////////////////////////
// XDocHostUI_DblClk interface

DWORD RHtmlView::GetXDocHostUI_DblClk()
{
	return m_pROccManager.m_pROleControlSite->GetXDocHostUI_DblClk();
}

void RHtmlView::SetXDocHostUI_DblClk(DWORD dwSet)
{
	m_pROccManager.m_pROleControlSite->SetXDocHostUI_DblClk(dwSet);
	Navigate2(GetLocationURL(), 0, NULL, NULL);
}


/////////////////////////////////////////////////////////////////////////////
// XDocHostUI_Flag interface

DWORD RHtmlView::GetXDocHostUI_Flag()
{
	return m_pROccManager.m_pROleControlSite->GetXDocHostUI_Flag();
}

void RHtmlView::SetXDocHostUI_Flag(DWORD dwSet)
{
	m_pROccManager.m_pROleControlSite->SetXDocHostUI_Flag(dwSet);
	Navigate2(GetLocationURL(), 0, NULL, NULL);
}

BOOL RHtmlView::GetXDocHostUIFlag_Dialog()
{
	return GetXDocHostUI_Flag() & DOCHOSTUIFLAG_DIALOG;
}

BOOL RHtmlView::GetXDocHostUIFlag_DisableHelpMenu()
{
	return GetXDocHostUI_Flag() & DOCHOSTUIFLAG_DISABLE_HELP_MENU;
}

BOOL RHtmlView::GetXDocHostUIFlag_No3dBorder()
{
	return GetXDocHostUI_Flag() & DOCHOSTUIFLAG_NO3DBORDER;
}

BOOL RHtmlView::GetXDocHostUIFlag_ScrollNo()
{
	return GetXDocHostUI_Flag() & DOCHOSTUIFLAG_SCROLL_NO;
}

BOOL RHtmlView::GetXDocHostUIFlag_DisableScriptInactive()
{
	return GetXDocHostUI_Flag() & DOCHOSTUIFLAG_DISABLE_SCRIPT_INACTIVE;
}

BOOL RHtmlView::GetXDocHostUIFlag_OpenNewWin()
{
	return GetXDocHostUI_Flag() & DOCHOSTUIFLAG_OPENNEWWIN;
}

BOOL RHtmlView::GetXDocHostUIFlag_DisableOffscreen()
{
	return GetXDocHostUI_Flag() & DOCHOSTUIFLAG_DISABLE_OFFSCREEN;
}

BOOL RHtmlView::GetXDocHostUIFlag_FlatScrollbar()
{
	return GetXDocHostUI_Flag() & DOCHOSTUIFLAG_FLAT_SCROLLBAR;
}

BOOL RHtmlView::GetXDocHostUIFlag_DivBlockDefault()
{
	return GetXDocHostUI_Flag() & DOCHOSTUIFLAG_DIV_BLOCKDEFAULT;
}

BOOL RHtmlView::GetXDocHostUIFlag_ActivateClienthitOnly()
{
	return GetXDocHostUI_Flag() & DOCHOSTUIFLAG_ACTIVATE_CLIENTHIT_ONLY;
}

void RHtmlView::SetXDocHostUIFlag_Dialog(BOOL bSet)
{
	DWORD dwFlags = GetXDocHostUI_Flag();
	bSet ? dwFlags |= DOCHOSTUIFLAG_DIALOG : dwFlags &= ~DOCHOSTUIFLAG_DIALOG;
	SetXDocHostUI_Flag(dwFlags);
}

void RHtmlView::SetXDocHostUIFlag_DisableHelpMenu(BOOL bSet)
{
	DWORD dwFlags = GetXDocHostUI_Flag();
	bSet ? dwFlags |= DOCHOSTUIFLAG_DISABLE_HELP_MENU : dwFlags &= ~DOCHOSTUIFLAG_DISABLE_HELP_MENU;
	SetXDocHostUI_Flag(dwFlags);
}

void RHtmlView::SetXDocHostUIFlag_No3dBorder(BOOL bSet)
{
	DWORD dwFlags = GetXDocHostUI_Flag();
	bSet ? dwFlags |= DOCHOSTUIFLAG_NO3DBORDER : dwFlags &= ~DOCHOSTUIFLAG_NO3DBORDER;
	SetXDocHostUI_Flag(dwFlags);
}

void RHtmlView::SetXDocHostUIFlag_ScrollNo(BOOL bSet)
{
	DWORD dwFlags = GetXDocHostUI_Flag();
	bSet ? dwFlags |= DOCHOSTUIFLAG_SCROLL_NO : dwFlags &= ~DOCHOSTUIFLAG_SCROLL_NO;
	SetXDocHostUI_Flag(dwFlags);
}

void RHtmlView::SetXDocHostUIFlag_DisableScriptInactive(BOOL bSet)
{
	DWORD dwFlags = GetXDocHostUI_Flag();
	bSet ? dwFlags |= DOCHOSTUIFLAG_DISABLE_SCRIPT_INACTIVE : dwFlags &= ~DOCHOSTUIFLAG_DISABLE_SCRIPT_INACTIVE;
	SetXDocHostUI_Flag(dwFlags);
}

void RHtmlView::SetXDocHostUIFlag_OpenNewWin(BOOL bSet)
{
	DWORD dwFlags = GetXDocHostUI_Flag();
	bSet ? dwFlags |= DOCHOSTUIFLAG_OPENNEWWIN : dwFlags &= ~DOCHOSTUIFLAG_OPENNEWWIN;
	SetXDocHostUI_Flag(dwFlags);
}

void RHtmlView::SetXDocHostUIFlag_DisableOffscreen(BOOL bSet)
{
	DWORD dwFlags = GetXDocHostUI_Flag();
	bSet ? dwFlags |= DOCHOSTUIFLAG_DISABLE_OFFSCREEN : dwFlags &= ~DOCHOSTUIFLAG_DISABLE_OFFSCREEN;
	SetXDocHostUI_Flag(dwFlags);
}

void RHtmlView::SetXDocHostUIFlag_FlatScrollbar(BOOL bSet)
{
	DWORD dwFlags = GetXDocHostUI_Flag();
	bSet ? dwFlags |= DOCHOSTUIFLAG_FLAT_SCROLLBAR : dwFlags &= ~DOCHOSTUIFLAG_FLAT_SCROLLBAR;
	SetXDocHostUI_Flag(dwFlags);
}

void RHtmlView::SetXDocHostUIFlag_DivBlockDefault(BOOL bSet)
{
	DWORD dwFlags = GetXDocHostUI_Flag();
	bSet ? dwFlags |= DOCHOSTUIFLAG_DIV_BLOCKDEFAULT : dwFlags &= ~DOCHOSTUIFLAG_DIV_BLOCKDEFAULT;
	SetXDocHostUI_Flag(dwFlags);
}

void RHtmlView::SetXDocHostUIFlag_ActivateClienthitOnly(BOOL bSet)
{
	DWORD dwFlags = GetXDocHostUI_Flag();
	bSet ? dwFlags |= DOCHOSTUIFLAG_ACTIVATE_CLIENTHIT_ONLY : dwFlags &= ~DOCHOSTUIFLAG_ACTIVATE_CLIENTHIT_ONLY;
	SetXDocHostUI_Flag(dwFlags);
}


/////////////////////////////////////////////////////////////////////////////
// Updated functions

void RHtmlView::SetRegisterAsBrowser(BOOL bNewValue)
{
	CHtmlView::SetRegisterAsBrowser(bNewValue);
	Navigate2(GetLocationURL(), 0, NULL, NULL);
}

void RHtmlView::SetRegisterAsDropTarget(BOOL bNewValue)
{
	CHtmlView::SetRegisterAsDropTarget(bNewValue);
	Navigate2(GetLocationURL(), 0, NULL, NULL);
}

void RHtmlView::SetSilent(BOOL bNewValue)
{
	CHtmlView::SetSilent(bNewValue);
	Navigate2(GetLocationURL(), 0, NULL, NULL);
}

void RHtmlView::SetTheaterMode(BOOL bNewValue)
{
	CHtmlView::SetTheaterMode(bNewValue);
	Navigate2(GetLocationURL(), 0, NULL, NULL);
}
